Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkPlanes Class Reference

`#include <vtkPlanes.h>`

Inheritance diagram for vtkPlanes:

[legend]
Collaboration diagram for vtkPlanes:

[legend]
List of all members.

## Detailed Description

implicit function for convex set of planes

Date:
  2002/12/26 18:24:21

Revision:
  1.12

vtkPlanes computes the implicit function and function gradient for a set of planes. The planes must define a convex space.

The function value is the closest first order distance of a point to the convex region defined by the planes. The function gradient is the plane normal at the function value. Note that the normals must point outside of the convex region. Thus, a negative function value means that a point is inside the convex region.

There are several methods to define the set of planes. The most general is to supply an instance of vtkPoints and an instance of vtkDataArray. (The points define a point on the plane, and the normals corresponding plane normals.) Two other specialized ways are to 1) supply six planes defining the view frustrum of a camera, and 2) provide a bounding box.

See also:
  vtkCamera

Created by:
  - Biddiscombe, John

CVS contributions (if > 5%):
  - Biddiscombe, John (60%)
  - Schroeder, Will (26%)
  - Geveci, Berk (8%)

CVS logs (CVSweb):
  - .`cxx` (`/Common/vtkPlanes.cxx)`
  - .`h` (`/Common/vtkPlanes.h)`

Examples:
  vtkPlanes (Examples)

Tests:
  vtkPlanes (Tests)

Definition at line 68 of file vtkPlanes.h.

## Public Types
typedef vtkImplicitFunction | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | EvaluateGradient (float x[3], float n[3])
void | SetFrustumPlanes (float planes[24])
int | GetNumberOfPlanes ()
vtkPlane * | GetPlane (int i)
float | EvaluateFunction (float x[3])
float | EvaluateFunction (float x, float y, float z)
virtual void | SetPoints (vtkPoints *)
virtual vtkPoints * | GetPoints ()
void | SetNormals (vtkDataArray *normals)
virtual vtkDataArray * | GetNormals ()
void | SetBounds (float bounds[6])
void | SetBounds (float xmin, float xmax, float ymin, float ymax, float zmin, float zmax)
## Static Public Methods
vtkPlanes * | New ()
int | IsTypeOf (const char *type)
vtkPlanes * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkPlanes ()
| ~vtkPlanes ()
## Protected Attributes
vtkPoints * | Points
vtkDataArray * | Normals
vtkPlane * | Plane

## Member Typedef Documentation

typedef vtkImplicitFunction vtkPlanes::Superclass

| Reimplemented from vtkImplicitFunction. Definition at line 72 of file vtkPlanes.h.

## Constructor & Destructor Documentation

vtkPlanes::vtkPlanes | ( |  | ) | `[protected]`

vtkPlanes::~vtkPlanes | ( |  | ) | `[protected]`

## Member Function Documentation

vtkPlanes* vtkPlanes::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkPlanes::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkImplicitFunction.

int vtkPlanes::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkImplicitFunction.

virtual int vtkPlanes::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkImplicitFunction.

vtkPlanes* vtkPlanes::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkImplicitFunction.

void vtkPlanes::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkImplicitFunction.

float vtkPlanes::EvaluateFunction | ( | float | x[3] | ) | `[virtual]`

| Evaluate plane equations. Return smallest absolute value. Implements vtkImplicitFunction.

float vtkPlanes::EvaluateFunction | ( | float | x,
|  | float | y,
|  | float | z
| ) | `[inline]`

| Evaluate plane equations. Return smallest absolute value. Reimplemented from vtkImplicitFunction. Definition at line 78 of file vtkPlanes.h. References vtkImplicitFunction::EvaluateFunction().

void vtkPlanes::EvaluateGradient | ( | float | x[3],
|  | float | n[3]
| ) | `[virtual]`

| Evaluate planes gradient. Implements vtkImplicitFunction.

virtual void vtkPlanes::SetPoints | ( | vtkPoints * |  | ) | `[virtual]`

| Specify a list of points defining points through which the planes pass.

virtual vtkPoints* vtkPlanes::GetPoints | ( |  | ) | `[virtual]`

| Specify a list of points defining points through which the planes pass.

void vtkPlanes::SetNormals | ( | vtkDataArray * | normals | ) |

| Specify a list of normal vectors for the planes. There is a one-to-one correspondence between plane points and plane normals.

virtual vtkDataArray* vtkPlanes::GetNormals | ( |  | ) | `[virtual]`

| Specify a list of normal vectors for the planes. There is a one-to-one correspondence between plane points and plane normals.

void vtkPlanes::SetFrustumPlanes | ( | float | planes[24] | ) |

| An alternative method to specify six planes defined by the camera view frustrum. See vtkCamera::GetFrustumPlanes() documentation.

void vtkPlanes::SetBounds | ( | float | bounds[6] | ) |

| An alternative method to specify six planes defined by a bounding box. The bounding box is a six-vector defined as (xmin,xmax,ymin,ymax,zmin,zmax). It defines six planes orthogonal to the x-y-z coordinate axes.

void vtkPlanes::SetBounds | ( | float | xmin,
|  | float | xmax,
|  | float | ymin,
|  | float | ymax,
|  | float | zmin,
|  | float | zmax
| ) |

| An alternative method to specify six planes defined by a bounding box. The bounding box is a six-vector defined as (xmin,xmax,ymin,ymax,zmin,zmax). It defines six planes orthogonal to the x-y-z coordinate axes.

int vtkPlanes::GetNumberOfPlanes | ( |  | ) |

| Return the number of planes in the set of planes.

vtkPlane* vtkPlanes::GetPlane | ( | int | i | ) |

| Create and return a pointer to a vtkPlane object at the ith position. It is your responsibility to delete the vtkPlane when done with it. Asking for a plane outside the allowable range returns NULL.

## Member Data Documentation

vtkPoints* vtkPlanes::Points`[protected]`

| Definition at line 125 of file vtkPlanes.h.

vtkDataArray* vtkPlanes::Normals`[protected]`

| Definition at line 126 of file vtkPlanes.h.

vtkPlane* vtkPlanes::Plane`[protected]`

| Definition at line 127 of file vtkPlanes.h.

The documentation for this class was generated from the following file:

- Common/vtkPlanes.h